{.$DEFINE WRITELANG}//Write default.ini with language?
unit CPSelect;

interface

uses
  CodeConvTools,
  Windows,
  Forms,
  Classes,
  ExtCtrls,
  StdCtrls,
  Controls,
  OffBtn,
  Translator;

type
  TCodePageSelect = class(TForm)
    SelectCPLabel: TLabel;
    FileLabel: TLabel;
    CodePageGroup: TRadioGroup;
    ConvertButton: TOffice97Button;
    CancelButton: TOffice97Button;
    CaseGroup: TRadioGroup;
    CRLFGroup: TRadioGroup;
    WebLabel: TLabel;
    DetectedCPLabel: TLabel;
    CPLabel: TLabel;
    Translator: TTranslator;
    procedure CancelButtonClick(Sender: TObject);
    procedure ConvertButtonClick(Sender: TObject);
    procedure WebLabelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TranslatorAfterTranslation(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    CP: TCodePage;
  end;

var
  CodePageSelect: TCodePageSelect;

implementation
uses Progress,
  ShellApi,
  SysUtils,
  Registry,
  CommonData;
{$R *.DFM}

procedure TCodePageSelect.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TCodePageSelect.ConvertButtonClick(Sender: TObject);
var
  I: Integer;
begin
  CP := FirstCodePage;
  for I := 1 to (CodePageGroup.ItemIndex) do
    CP := Succ(CP);
  ModalResult := mrOk;
//   Close;
end;

procedure TCodePageSelect.WebLabelClick(Sender: TObject);
begin
  ShellExecute(ValidParentForm(Self).Handle, 'open', PChar(ProgramWeb), nil, nil,
    SW_SHOWNORMAL);
end;

procedure TCodePageSelect.FormShow(Sender: TObject);
var
  OptPath: string;
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_CURRENT_USER;
    OpenKey(RegPath, True);
    try
      OptPath := ReadString('Path');
    except
      OptPath := ExtractFilePath(ParamStr(0));
    end;
  finally
    Free;
  end;
  Translator.RootComponent := Self;
  Translator.AddRootName := True;
  Translator.UseEmpty := False;
{$IFDEF WRITELANG}

  Translator.LanguageFile := OptPath + DefaultLanguageFile;
  Translator.CreateIniFile;

{$ENDIF}
  if FileExists(OptPath + LanguageFile) then
  begin
    Translator.LanguageFile := OptPath + LanguageFile;
    Translator.Translate;
  end;
  WebLabel.Caption := AuthorWeb;
end;

procedure TCodePageSelect.TranslatorAfterTranslation(Sender: TObject);
begin
  Caption := AppName + ' ' + Translator.TranslateUserMessage('Version', 'version') + ' ' + VersionString;
end;

procedure TCodePageSelect.FormMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  MousePos := ScreenToClient(MousePos);
  if (MousePos.Y > CodePageGroup.BoundsRect.Top) and
    (MousePos.Y < CodePageGroup.BoundsRect.Bottom) and
    (MousePos.X > CodePageGroup.BoundsRect.Left) and
    (MousePos.X < CodePageGroup.BoundsRect.Right) then
  begin
    if WheelDelta < 0 then
    begin
      if CodePageGroup.ItemIndex < CodePageGroup.Items.Count then
        CodePageGroup.ItemIndex := CodePageGroup.ItemIndex + 1;
    end
    else
      if CodePageGroup.ItemIndex > 0 then
        CodePageGroup.ItemIndex := CodePageGroup.ItemIndex - 1;
    begin
    end;
    Handled := True;
  end
  else
    if (MousePos.Y > CRLFGroup.BoundsRect.Top) and
    (MousePos.Y < CRLFGroup.BoundsRect.Bottom) and
      (MousePos.X > CRLFGroup.BoundsRect.Left) and
      (MousePos.X < CRLFGroup.BoundsRect.Right) then
    begin
      if WheelDelta < 0 then
      begin
        if CRLFGroup.ItemIndex < CRLFGroup.Items.Count then
          CRLFGroup.ItemIndex := CRLFGroup.ItemIndex + 1;
      end
      else
        if CRLFGroup.ItemIndex > 0 then
          CRLFGroup.ItemIndex := CRLFGroup.ItemIndex - 1;
      begin
      end;
      Handled := True;
    end
    else
      if (MousePos.Y > CaseGroup.BoundsRect.Top) and
      (MousePos.Y < CaseGroup.BoundsRect.Bottom) and
        (MousePos.X > CaseGroup.BoundsRect.Left) and
        (MousePos.X < CaseGroup.BoundsRect.Right) then
      begin
        if WheelDelta < 0 then
        begin
          if CaseGroup.ItemIndex < CaseGroup.Items.Count then
            CaseGroup.ItemIndex := CaseGroup.ItemIndex + 1;
        end
        else
          if CaseGroup.ItemIndex > 0 then
            CaseGroup.ItemIndex := CaseGroup.ItemIndex - 1;
        begin
        end;
        Handled := True;
      end
      else
        Handled := False;
end;

end.

