unit EasterEgg;

interface

uses
  Forms,
  Controls,
  Grids,
  Classes,
  StdCtrls;

type
  TEasterEggForm = class (TForm)
    TextEdit: TEdit;
    TranslMemo: TMemo;
    CaseCheck: TCheckBox;
    procedure TextEditChange (Sender: TObject);
    procedure FormShow (Sender: TObject);
    procedure TranslMemoKeyUp (Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EasterEggForm: TEasterEggForm;

function MakeLen (const S: string; const L: Integer): string;

implementation
uses CodeConvTools,
  Options,
  CommonData, Main;

{$R *.DFM}

function MakeLen (const S: string; const L: Integer): string;
var
  i: Integer;
begin
  Result := S;
  i := Pos (' ...', Result);
  Delete (Result, i, Length (Result) + 1 - i);

  while Length (Result) < L do
    Result := Result + ' ';
end;

procedure TEasterEggForm.TextEditChange (Sender: TObject);
var
  CP: TCodePage;
begin
  case CaseCheck.State of
    cbGrayed:
      for CP := cp895 to cpAscii do
        EasterEggForm.TranslMemo.Lines[Ord (CP)] := MakeLen (CodeConvMainForm.ToCPCombo.Items[Ord (CP)],
          28) + #9 + ConvertString (EasterEggForm.TextEdit.Text, cp1250, CP, CaseNoChange);
    cbChecked:
      for CP := cp895 to cpAscii do
        EasterEggForm.TranslMemo.Lines[Ord (CP)] := MakeLen (CodeConvMainForm.ToCPCombo.Items[Ord (CP)],
          28) + #9 + ConvertString (EasterEggForm.TextEdit.Text, cp1250, CP, CaseHigh);
    cbUnchecked:
      for CP := cp895 to cpAscii do
        EasterEggForm.TranslMemo.Lines[Ord (CP)] := MakeLen (CodeConvMainForm.ToCPCombo.Items[Ord (CP)],
          28) + #9 + ConvertString (EasterEggForm.TextEdit.Text, cp1250, CP, CaseLow);
  else
    for CP := cp895 to cpAscii do
      EasterEggForm.TranslMemo.Lines[Ord (CP)] := MakeLen (CodeConvMainForm.ToCPCombo.Items[Ord (CP)],
        28) + #9 + ConvertString (EasterEggForm.TextEdit.Text, cp1250, CP, CaseNoChange);
  end;
end;

procedure TEasterEggForm.FormShow (Sender: TObject);
begin
  TextEdit.Text := PrisernaVeta;
end;

procedure TEasterEggForm.TranslMemoKeyUp (Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) and (Key = Ord ('A')) then TranslMemo.SelectAll;
end;

end.

